From: =?utf-8?q?Christian_G=C3=B6ttsche?= <cgzones@googlemail.com>
Date: Tue, 12 May 2020 18:07:26 +0200
Subject: introduce custom cmake targets

Avoid multiple generation of dependent files
If timed badly this can cause parallel builds to fail
---
 cursors.cmake | 15 +++++++++++++--
 1 file changed, 13 insertions(+), 2 deletions(-)

diff --git a/cursors.cmake b/cursors.cmake
index dcaa2b4..9933a24 100644
--- a/cursors.cmake
+++ b/cursors.cmake
@@ -24,6 +24,11 @@ macro(add_cursor cursor color theme dpi)
                                                ${CMAKE_BINARY_DIR}/oxy-${theme}/svg/${cursor}.svg
                                                > /dev/null 2>&1
                           )
+        # Use a wrapper target, cause add_dependencies() does not accept commands
+        add_custom_target(WrapperTarget_oxy-${theme}_png_${resolution}_${cursor}
+                          DEPENDS ${CMAKE_BINARY_DIR}/oxy-${theme}/png/${resolution}/${cursor}.png
+                         )
+        add_dependencies(render_pngs_${theme} WrapperTarget_oxy-${theme}_png_${resolution}_${cursor})
     endforeach(resolution)
 endmacro(add_cursor)
 
@@ -52,20 +57,23 @@ macro(add_x_cursor theme cursor dpi)
     # Use the adopted x cursor config file and the png files to produce the cursor file
     if(NOT WIN32)
     add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/oxy-${theme}/cursors/${cursor}
-                       DEPENDS ${inputs} ${CMAKE_BINARY_DIR}/oxy-${theme}/config/${cursor}.in
+                       DEPENDS render_pngs_${theme} ${inputs} ${CMAKE_BINARY_DIR}/oxy-${theme}/config/${cursor}.in
                        COMMAND ${XCURSORGEN} -p ${CMAKE_BINARY_DIR}/oxy-${theme}/png
                                              ${CMAKE_BINARY_DIR}/oxy-${theme}/config/${cursor}.in
                                              ${CMAKE_BINARY_DIR}/oxy-${theme}/cursors/${cursor}
                       )
     else(NOT WIN32)
     add_custom_command(OUTPUT ${CMAKE_BINARY_DIR}/oxy-${theme}/cursors/${cursor}
-                       DEPENDS ${inputs} ${CMAKE_BINARY_DIR}/oxy-${theme}/config/${cursor}.in
+                       DEPENDS render_pngs_${theme} {inputs} ${CMAKE_BINARY_DIR}/oxy-${theme}/config/${cursor}.in
                        COMMAND "${CMAKE_SOURCE_DIR}/wincursor.py" ${CMAKE_BINARY_DIR}/oxy-${theme}/png
                                              ${CMAKE_BINARY_DIR}/oxy-${theme}/config/${cursor}.in
                                              ${CMAKE_BINARY_DIR}/wincursors/oxy-${theme}
                                              ${CMAKE_BINARY_DIR}/oxy-${theme}/cursors/${cursor}
                       )
     endif(NOT WIN32)
+    add_custom_target(WrapperTarget_oxy-${theme}_cursors_${cursor}
+                      DEPENDS ${CMAKE_BINARY_DIR}/oxy-${theme}/cursors/${cursor}
+                     )
 endmacro(add_x_cursor)
 
 file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/packages)
@@ -87,6 +95,8 @@ macro(add_theme color theme dpi)
     file(MAKE_DIRECTORY ${CMAKE_BINARY_DIR}/wincursors/oxy-${theme})
     endif(WIN32)
     set(${theme}_cursors)
+    # add target to avoid multiple generate calls for dependency files
+    add_custom_target(render_pngs_${theme})
     # render SVG to PNG files
     foreach(svg ${SVGS})
         string(REGEX REPLACE ".*/" "" cursor ${svg})           # use relative paths
@@ -97,6 +107,7 @@ macro(add_theme color theme dpi)
     foreach(cursor ${CURSORS})
         add_x_cursor(${theme} ${cursor} ${resolutions})
         list(APPEND ${theme}_cursors ${CMAKE_BINARY_DIR}/oxy-${theme}/cursors/${cursor})
+        list(APPEND ${theme}_cursors WrapperTarget_oxy-${theme}_cursors_${cursor})
     endforeach(cursor)
     # add the symbolic links
     foreach(symlink ${SYMLINKS_PATHS})
